/* book-view.c generated by valac 0.24.0, the Vala compiler
 * generated from book-view.vala, do not modify */

/*
 * Copyright (C) 2009-2011 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/* FIXME: When scrolling, copy existing render sideways?*/
/* FIXME: Only render pages that change and only the part that changed*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_BOOK_VIEW (book_view_get_type ())
#define BOOK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOK_VIEW, BookView))
#define BOOK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOK_VIEW, BookViewClass))
#define IS_BOOK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOK_VIEW))
#define IS_BOOK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOK_VIEW))
#define BOOK_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOK_VIEW, BookViewClass))

typedef struct _BookView BookView;
typedef struct _BookViewClass BookViewClass;
typedef struct _BookViewPrivate BookViewPrivate;

#define TYPE_BOOK (book_get_type ())
#define BOOK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOK, Book))
#define BOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOK, BookClass))
#define IS_BOOK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOK))
#define IS_BOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOK))
#define BOOK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOK, BookClass))

typedef struct _Book Book;
typedef struct _BookClass BookClass;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_PAGE_VIEW (page_view_get_type ())
#define PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW, PageView))
#define PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW, PageViewClass))
#define IS_PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW))
#define IS_PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW))
#define PAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW, PageViewClass))

typedef struct _PageView PageView;
typedef struct _PageViewClass PageViewClass;
#define _book_unref0(var) ((var == NULL) ? NULL : (var = (book_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _page_view_unref0(var) ((var == NULL) ? NULL : (var = (page_view_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _page_unref0(var) ((var == NULL) ? NULL : (var = (page_unref (var), NULL)))

struct _BookView {
	GtkVBox parent_instance;
	BookViewPrivate * priv;
};

struct _BookViewClass {
	GtkVBoxClass parent_class;
};

struct _BookViewPrivate {
	Book* book;
	GHashTable* page_data;
	gboolean need_layout;
	gboolean laying_out;
	gboolean show_selected_page;
	PageView* selected_page;
	GtkWidget* drawing_area;
	GtkScrollbar* scroll;
	GtkAdjustment* adjustment;
	GdkCursorType cursor;
};


static gpointer book_view_parent_class = NULL;

GType book_view_get_type (void) G_GNUC_CONST;
gpointer book_ref (gpointer instance);
void book_unref (gpointer instance);
GParamSpec* param_spec_book (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_book (GValue* value, gpointer v_object);
void value_take_book (GValue* value, gpointer v_object);
gpointer value_get_book (const GValue* value);
GType book_get_type (void) G_GNUC_CONST;
gpointer page_ref (gpointer instance);
void page_unref (gpointer instance);
GParamSpec* param_spec_page (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_page (GValue* value, gpointer v_object);
void value_take_page (GValue* value, gpointer v_object);
gpointer value_get_page (const GValue* value);
GType page_get_type (void) G_GNUC_CONST;
gpointer page_view_ref (gpointer instance);
void page_view_unref (gpointer instance);
GParamSpec* param_spec_page_view (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_page_view (GValue* value, gpointer v_object);
void value_take_page_view (GValue* value, gpointer v_object);
gpointer value_get_page_view (const GValue* value);
GType page_view_get_type (void) G_GNUC_CONST;
#define BOOK_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BOOK_VIEW, BookViewPrivate))
enum  {
	BOOK_VIEW_DUMMY_PROPERTY
};
static void book_view_add_cb (BookView* self, Book* book, Page* page);
static void _book_view_add_cb_book_page_added (Book* _sender, Page* page, gpointer self);
static void book_view_remove_cb (BookView* self, Book* book, Page* page);
static void _book_view_remove_cb_book_page_removed (Book* _sender, Page* page, gpointer self);
static void book_view_reorder_cb (BookView* self, Book* book);
static void _book_view_reorder_cb_book_reordered (Book* _sender, gpointer self);
static void book_view_clear_cb (BookView* self, Book* book);
static void _book_view_clear_cb_book_cleared (Book* _sender, gpointer self);
static gboolean book_view_configure_cb (BookView* self, GtkWidget* widget, GdkEventConfigure* event);
static gboolean _book_view_configure_cb_gtk_widget_configure_event (GtkWidget* _sender, GdkEventConfigure* event, gpointer self);
static gboolean book_view_draw_cb (BookView* self, GtkWidget* widget, cairo_t* context);
static gboolean _book_view_draw_cb_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
static gboolean book_view_motion_cb (BookView* self, GtkWidget* widget, GdkEventMotion* event);
static gboolean _book_view_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self);
static gboolean book_view_key_cb (BookView* self, GtkWidget* widget, GdkEventKey* event);
static gboolean _book_view_key_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static gboolean book_view_button_cb (BookView* self, GtkWidget* widget, GdkEventButton* event);
static gboolean _book_view_button_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean _book_view_button_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean book_view_focus_cb (BookView* self, GtkWidget* widget, GdkEventFocus* event);
static gboolean _book_view_focus_cb_gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
static gboolean _book_view_focus_cb_gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
static void book_view_scroll_cb (BookView* self, GtkAdjustment* adjustment);
static void _book_view_scroll_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
BookView* book_view_new (Book* book);
BookView* book_view_construct (GType object_type, Book* book);
guint book_get_n_pages (Book* self);
Page* book_get_page (Book* self, gint page_number);
void book_view_select_page (BookView* self, Page* page);
static void _page_unref0_ (gpointer var);
static void _page_view_unref0_ (gpointer var);
static PageView* book_view_get_nth_page (BookView* self, gint n);
static PageView* book_view_get_next_page (BookView* self, PageView* page);
Page* page_view_get_page (PageView* self);
static PageView* book_view_get_prev_page (BookView* self, PageView* page);
static void book_view_page_view_changed_cb (BookView* self, PageView* page);
void book_view_redraw (BookView* self);
static void book_view_page_view_size_changed_cb (BookView* self, PageView* page);
PageView* page_view_new (Page* page);
PageView* page_view_construct (GType object_type, Page* page);
static void _book_view_page_view_changed_cb_page_view_changed (PageView* _sender, gpointer self);
static void _book_view_page_view_size_changed_cb_page_view_size_changed (PageView* _sender, gpointer self);
static void book_view_set_selected_page (BookView* self, PageView* page);
void page_view_set_selected (PageView* self, gboolean selected);
static void book_view_set_x_offset (BookView* self, gint offset);
static gint book_view_get_x_offset (BookView* self);
static void book_view_show_page_view (BookView* self, PageView* page);
gint page_view_get_x_offset (PageView* self);
gint page_view_get_width (PageView* self);
static void book_view_select_page_view (BookView* self, PageView* page);
Page* book_view_get_selected (BookView* self);
Book* book_view_get_book (BookView* self);
static void book_view_layout_into (BookView* self, gint width, gint height, gint* book_width, gint* book_height);
gint page_get_dpi (Page* self);
gint page_get_width (Page* self);
gint page_get_height (Page* self);
void page_view_set_width (PageView* self, gint width);
void page_view_set_height (PageView* self, gint height);
gint page_view_get_height (PageView* self);
void page_view_set_x_offset (PageView* self, gint offset);
void page_view_set_y_offset (PageView* self, gint offset);
static void book_view_layout (BookView* self);
void page_view_render (PageView* self, cairo_t* context);
gboolean page_view_get_selected (PageView* self);
gint page_view_get_y_offset (PageView* self);
static PageView* book_view_get_page_at (BookView* self, gint x, gint y, gint* x_, gint* y_);
void page_view_button_press (PageView* self, gint x, gint y);
void page_view_button_release (PageView* self, gint x, gint y);
static void book_view_set_cursor (BookView* self, GdkCursorType cursor);
void page_view_motion (PageView* self, gint x, gint y);
GdkCursorType page_view_get_cursor (PageView* self);
void book_view_select_next_page (BookView* self);
void book_view_select_prev_page (BookView* self);
static void g_cclosure_user_marshal_VOID__PAGE (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void book_view_finalize (GObject* obj);


static void _book_view_add_cb_book_page_added (Book* _sender, Page* page, gpointer self) {
#line 90 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_add_cb ((BookView*) self, _sender, page);
#line 204 "book-view.c"
}


static void _book_view_remove_cb_book_page_removed (Book* _sender, Page* page, gpointer self) {
#line 91 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_remove_cb ((BookView*) self, _sender, page);
#line 211 "book-view.c"
}


static void _book_view_reorder_cb_book_reordered (Book* _sender, gpointer self) {
#line 92 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_reorder_cb ((BookView*) self, _sender);
#line 218 "book-view.c"
}


static void _book_view_clear_cb_book_cleared (Book* _sender, gpointer self) {
#line 93 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_clear_cb ((BookView*) self, _sender);
#line 225 "book-view.c"
}


static gboolean _book_view_configure_cb_gtk_widget_configure_event (GtkWidget* _sender, GdkEventConfigure* event, gpointer self) {
	gboolean result;
	result = book_view_configure_cb ((BookView*) self, _sender, event);
#line 94 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 234 "book-view.c"
}


static gboolean _book_view_draw_cb_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = book_view_draw_cb ((BookView*) self, _sender, cr);
#line 95 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 243 "book-view.c"
}


static gboolean _book_view_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self) {
	gboolean result;
	result = book_view_motion_cb ((BookView*) self, _sender, event);
#line 96 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 252 "book-view.c"
}


static gboolean _book_view_key_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
	gboolean result;
	result = book_view_key_cb ((BookView*) self, _sender, event);
#line 97 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 261 "book-view.c"
}


static gboolean _book_view_button_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = book_view_button_cb ((BookView*) self, _sender, event);
#line 98 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 270 "book-view.c"
}


static gboolean _book_view_button_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = book_view_button_cb ((BookView*) self, _sender, event);
#line 99 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 279 "book-view.c"
}


static gboolean _book_view_focus_cb_gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	gboolean result;
	result = book_view_focus_cb ((BookView*) self, _sender, event);
#line 100 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 288 "book-view.c"
}


static gboolean _book_view_focus_cb_gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	gboolean result;
	result = book_view_focus_cb ((BookView*) self, _sender, event);
#line 101 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 297 "book-view.c"
}


static void _book_view_scroll_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
#line 102 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_scroll_cb ((BookView*) self, _sender);
#line 304 "book-view.c"
}


static gpointer _book_ref0 (gpointer self) {
#line 44 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return self ? book_ref (self) : NULL;
#line 311 "book-view.c"
}


static void _page_unref0_ (gpointer var) {
#line 62 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	(var == NULL) ? NULL : (var = (page_unref (var), NULL));
#line 318 "book-view.c"
}


static void _page_view_unref0_ (gpointer var) {
#line 62 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	(var == NULL) ? NULL : (var = (page_view_unref (var), NULL));
#line 325 "book-view.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 72 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 332 "book-view.c"
}


BookView* book_view_construct (GType object_type, Book* book) {
	BookView * self = NULL;
	Book* _tmp0_ = NULL;
	Book* _tmp1_ = NULL;
	Book* _tmp12_ = NULL;
	Page* _tmp13_ = NULL;
	Page* _tmp14_ = NULL;
	Book* _tmp15_ = NULL;
	Book* _tmp16_ = NULL;
	Book* _tmp17_ = NULL;
	Book* _tmp18_ = NULL;
	GHashFunc _tmp19_ = NULL;
	GEqualFunc _tmp20_ = NULL;
	GHashTable* _tmp21_ = NULL;
	GtkDrawingArea* _tmp22_ = NULL;
	GtkWidget* _tmp23_ = NULL;
	GtkWidget* _tmp24_ = NULL;
	GtkWidget* _tmp25_ = NULL;
	GtkWidget* _tmp26_ = NULL;
	GtkScrollbar* _tmp27_ = NULL;
	GtkScrollbar* _tmp28_ = NULL;
	GtkAdjustment* _tmp29_ = NULL;
	GtkAdjustment* _tmp30_ = NULL;
	GtkScrollbar* _tmp31_ = NULL;
	GtkWidget* _tmp32_ = NULL;
	GtkWidget* _tmp33_ = NULL;
	GtkWidget* _tmp34_ = NULL;
	GtkWidget* _tmp35_ = NULL;
	GtkWidget* _tmp36_ = NULL;
	GtkWidget* _tmp37_ = NULL;
	GtkWidget* _tmp38_ = NULL;
	GtkWidget* _tmp39_ = NULL;
	GtkAdjustment* _tmp40_ = NULL;
	GtkWidget* _tmp41_ = NULL;
#line 42 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (book != NULL, NULL);
#line 42 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self = (BookView*) g_object_new (object_type, NULL);
#line 44 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = book;
#line 44 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = _book_ref0 (_tmp0_);
#line 44 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_book_unref0 (self->priv->book);
#line 44 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->book = _tmp1_;
#line 382 "book-view.c"
	{
		gint i = 0;
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		i = 0;
#line 387 "book-view.c"
		{
			gboolean _tmp2_ = FALSE;
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp2_ = TRUE;
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			while (TRUE) {
#line 394 "book-view.c"
				gint _tmp4_ = 0;
				Book* _tmp5_ = NULL;
				guint _tmp6_ = 0U;
				Page* page = NULL;
				Book* _tmp7_ = NULL;
				gint _tmp8_ = 0;
				Page* _tmp9_ = NULL;
				Book* _tmp10_ = NULL;
				Page* _tmp11_ = NULL;
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!_tmp2_) {
#line 406 "book-view.c"
					gint _tmp3_ = 0;
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp3_ = i;
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					i = _tmp3_ + 1;
#line 412 "book-view.c"
				}
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp2_ = FALSE;
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp4_ = i;
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp5_ = book;
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp6_ = book_get_n_pages (_tmp5_);
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!(((guint) _tmp4_) < _tmp6_)) {
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					break;
#line 426 "book-view.c"
				}
#line 49 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp7_ = book;
#line 49 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp8_ = i;
#line 49 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp9_ = book_get_page (_tmp7_, _tmp8_);
#line 49 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				page = _tmp9_;
#line 50 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp10_ = book;
#line 50 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp11_ = page;
#line 50 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				book_view_add_cb (self, _tmp10_, _tmp11_);
#line 47 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_unref0 (page);
#line 444 "book-view.c"
			}
		}
	}
#line 53 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp12_ = book;
#line 53 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp13_ = book_get_page (_tmp12_, 0);
#line 53 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp14_ = _tmp13_;
#line 53 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_select_page (self, _tmp14_);
#line 53 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_unref0 (_tmp14_);
#line 56 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp15_ = book;
#line 56 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp15_, "page-added", (GCallback) _book_view_add_cb_book_page_added, self, 0);
#line 57 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp16_ = book;
#line 57 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp16_, "page-removed", (GCallback) _book_view_remove_cb_book_page_removed, self, 0);
#line 58 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp17_ = book;
#line 58 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp17_, "reordered", (GCallback) _book_view_reorder_cb_book_reordered, self, 0);
#line 59 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp18_ = book;
#line 59 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp18_, "cleared", (GCallback) _book_view_clear_cb_book_cleared, self, 0);
#line 61 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 62 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp19_ = g_direct_hash;
#line 62 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp20_ = g_direct_equal;
#line 62 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp21_ = g_hash_table_new_full (_tmp19_, _tmp20_, _page_unref0_, _page_view_unref0_);
#line 62 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_g_hash_table_unref0 (self->priv->page_data);
#line 62 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->page_data = _tmp21_;
#line 63 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->cursor = GDK_ARROW;
#line 65 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp22_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 65 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_object_ref_sink (_tmp22_);
#line 65 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_g_object_unref0 (self->priv->drawing_area);
#line 65 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->drawing_area = (GtkWidget*) _tmp22_;
#line 66 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp23_ = self->priv->drawing_area;
#line 66 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gtk_widget_set_size_request (_tmp23_, 200, 100);
#line 67 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp24_ = self->priv->drawing_area;
#line 67 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gtk_widget_set_can_focus (_tmp24_, TRUE);
#line 68 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp25_ = self->priv->drawing_area;
#line 68 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gtk_widget_set_events (_tmp25_, (gint) (((((GDK_POINTER_MOTION_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_FOCUS_CHANGE_MASK) | GDK_STRUCTURE_MASK) | GDK_SCROLL_MASK));
#line 69 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp26_ = self->priv->drawing_area;
#line 69 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gtk_box_pack_start ((GtkBox*) self, _tmp26_, TRUE, TRUE, (guint) 0);
#line 71 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp27_ = (GtkScrollbar*) gtk_scrollbar_new (GTK_ORIENTATION_HORIZONTAL, NULL);
#line 71 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_object_ref_sink (_tmp27_);
#line 71 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_g_object_unref0 (self->priv->scroll);
#line 71 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->scroll = _tmp27_;
#line 72 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp28_ = self->priv->scroll;
#line 72 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp29_ = gtk_range_get_adjustment ((GtkRange*) _tmp28_);
#line 72 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp30_ = _g_object_ref0 (_tmp29_);
#line 72 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_g_object_unref0 (self->priv->adjustment);
#line 72 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->adjustment = _tmp30_;
#line 73 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp31_ = self->priv->scroll;
#line 73 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp31_, FALSE, TRUE, (guint) 0);
#line 75 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp32_ = self->priv->drawing_area;
#line 75 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp32_, "configure-event", (GCallback) _book_view_configure_cb_gtk_widget_configure_event, self, 0);
#line 76 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp33_ = self->priv->drawing_area;
#line 76 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp33_, "draw", (GCallback) _book_view_draw_cb_gtk_widget_draw, self, 0);
#line 77 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp34_ = self->priv->drawing_area;
#line 77 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp34_, "motion-notify-event", (GCallback) _book_view_motion_cb_gtk_widget_motion_notify_event, self, 0);
#line 78 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp35_ = self->priv->drawing_area;
#line 78 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp35_, "key-press-event", (GCallback) _book_view_key_cb_gtk_widget_key_press_event, self, 0);
#line 79 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp36_ = self->priv->drawing_area;
#line 79 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp36_, "button-press-event", (GCallback) _book_view_button_cb_gtk_widget_button_press_event, self, 0);
#line 80 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp37_ = self->priv->drawing_area;
#line 80 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp37_, "button-release-event", (GCallback) _book_view_button_cb_gtk_widget_button_release_event, self, 0);
#line 81 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp38_ = self->priv->drawing_area;
#line 81 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp38_, "focus-in-event", (GCallback) _book_view_focus_cb_gtk_widget_focus_in_event, self, G_CONNECT_AFTER);
#line 82 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp39_ = self->priv->drawing_area;
#line 82 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp39_, "focus-out-event", (GCallback) _book_view_focus_cb_gtk_widget_focus_out_event, self, G_CONNECT_AFTER);
#line 83 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp40_ = self->priv->adjustment;
#line 83 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (_tmp40_, "value-changed", (GCallback) _book_view_scroll_cb_gtk_adjustment_value_changed, self, 0);
#line 85 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp41_ = self->priv->drawing_area;
#line 85 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gtk_widget_show (_tmp41_);
#line 42 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return self;
#line 576 "book-view.c"
}


BookView* book_view_new (Book* book) {
#line 42 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return book_view_construct (TYPE_BOOK_VIEW, book);
#line 583 "book-view.c"
}


static gpointer _page_view_ref0 (gpointer self) {
#line 108 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return self ? page_view_ref (self) : NULL;
#line 590 "book-view.c"
}


static PageView* book_view_get_nth_page (BookView* self, gint n) {
	PageView* result = NULL;
	Page* page = NULL;
	Book* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	Page* _tmp2_ = NULL;
	GHashTable* _tmp3_ = NULL;
	gconstpointer _tmp4_ = NULL;
	PageView* _tmp5_ = NULL;
#line 105 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->book;
#line 107 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = n;
#line 107 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp2_ = book_get_page (_tmp0_, _tmp1_);
#line 107 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	page = _tmp2_;
#line 108 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp3_ = self->priv->page_data;
#line 108 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp4_ = g_hash_table_lookup (_tmp3_, page);
#line 108 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp5_ = _page_view_ref0 ((PageView*) _tmp4_);
#line 108 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	result = _tmp5_;
#line 108 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_unref0 (page);
#line 108 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 625 "book-view.c"
}


static PageView* book_view_get_next_page (BookView* self, PageView* page) {
	PageView* result = NULL;
	PageView* _tmp19_ = NULL;
	PageView* _tmp20_ = NULL;
#line 111 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 111 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 637 "book-view.c"
	{
		gint i = 0;
#line 113 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		i = 0;
#line 642 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 113 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp0_ = TRUE;
#line 113 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			while (TRUE) {
#line 649 "book-view.c"
				Page* p = NULL;
				Book* _tmp2_ = NULL;
				gint _tmp3_ = 0;
				Page* _tmp4_ = NULL;
				Page* _tmp5_ = NULL;
				Page* _tmp6_ = NULL;
				PageView* _tmp7_ = NULL;
				Page* _tmp8_ = NULL;
				Page* _tmp9_ = NULL;
				gboolean _tmp10_ = FALSE;
#line 113 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!_tmp0_) {
#line 662 "book-view.c"
					gint _tmp1_ = 0;
#line 113 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp1_ = i;
#line 113 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					i = _tmp1_ + 1;
#line 668 "book-view.c"
				}
#line 113 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp0_ = FALSE;
#line 115 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp2_ = self->priv->book;
#line 115 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp3_ = i;
#line 115 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp4_ = book_get_page (_tmp2_, _tmp3_);
#line 115 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				p = _tmp4_;
#line 116 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp5_ = p;
#line 116 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp5_ == NULL) {
#line 117 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_page_unref0 (p);
#line 117 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					break;
#line 688 "book-view.c"
				}
#line 118 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp6_ = p;
#line 118 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp7_ = page;
#line 118 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp8_ = page_view_get_page (_tmp7_);
#line 118 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp9_ = _tmp8_;
#line 118 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp10_ = _tmp6_ == _tmp9_;
#line 118 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_unref0 (_tmp9_);
#line 118 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp10_) {
#line 704 "book-view.c"
					Book* _tmp11_ = NULL;
					gint _tmp12_ = 0;
					Page* _tmp13_ = NULL;
					Page* _tmp14_ = NULL;
#line 120 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp11_ = self->priv->book;
#line 120 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp12_ = i;
#line 120 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp13_ = book_get_page (_tmp11_, _tmp12_ + 1);
#line 120 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_page_unref0 (p);
#line 120 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					p = _tmp13_;
#line 121 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp14_ = p;
#line 121 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					if (_tmp14_ != NULL) {
#line 723 "book-view.c"
						GHashTable* _tmp15_ = NULL;
						Page* _tmp16_ = NULL;
						gconstpointer _tmp17_ = NULL;
						PageView* _tmp18_ = NULL;
#line 122 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
						_tmp15_ = self->priv->page_data;
#line 122 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
						_tmp16_ = p;
#line 122 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
						_tmp17_ = g_hash_table_lookup (_tmp15_, _tmp16_);
#line 122 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
						_tmp18_ = _page_view_ref0 ((PageView*) _tmp17_);
#line 122 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
						result = _tmp18_;
#line 122 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
						_page_unref0 (p);
#line 122 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
						return result;
#line 742 "book-view.c"
					}
				}
#line 113 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_unref0 (p);
#line 747 "book-view.c"
			}
		}
	}
#line 126 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp19_ = page;
#line 126 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp20_ = _page_view_ref0 (_tmp19_);
#line 126 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	result = _tmp20_;
#line 126 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 759 "book-view.c"
}


static PageView* book_view_get_prev_page (BookView* self, PageView* page) {
	PageView* result = NULL;
	PageView* prev_page = NULL;
	PageView* _tmp0_ = NULL;
	PageView* _tmp1_ = NULL;
	PageView* _tmp17_ = NULL;
	PageView* _tmp18_ = NULL;
#line 129 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 129 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 131 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = page;
#line 131 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = _page_view_ref0 (_tmp0_);
#line 131 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	prev_page = _tmp1_;
#line 780 "book-view.c"
	{
		gint i = 0;
#line 132 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		i = 0;
#line 785 "book-view.c"
		{
			gboolean _tmp2_ = FALSE;
#line 132 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp2_ = TRUE;
#line 132 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			while (TRUE) {
#line 792 "book-view.c"
				Page* p = NULL;
				Book* _tmp4_ = NULL;
				gint _tmp5_ = 0;
				Page* _tmp6_ = NULL;
				Page* _tmp7_ = NULL;
				Page* _tmp8_ = NULL;
				PageView* _tmp9_ = NULL;
				Page* _tmp10_ = NULL;
				Page* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				GHashTable* _tmp13_ = NULL;
				Page* _tmp14_ = NULL;
				gconstpointer _tmp15_ = NULL;
				PageView* _tmp16_ = NULL;
#line 132 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!_tmp2_) {
#line 809 "book-view.c"
					gint _tmp3_ = 0;
#line 132 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp3_ = i;
#line 132 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					i = _tmp3_ + 1;
#line 815 "book-view.c"
				}
#line 132 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp2_ = FALSE;
#line 134 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp4_ = self->priv->book;
#line 134 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp5_ = i;
#line 134 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp6_ = book_get_page (_tmp4_, _tmp5_);
#line 134 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				p = _tmp6_;
#line 135 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp7_ = p;
#line 135 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp7_ == NULL) {
#line 136 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_page_unref0 (p);
#line 136 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					break;
#line 835 "book-view.c"
				}
#line 137 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp8_ = p;
#line 137 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp9_ = page;
#line 137 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp10_ = page_view_get_page (_tmp9_);
#line 137 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp11_ = _tmp10_;
#line 137 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp12_ = _tmp8_ == _tmp11_;
#line 137 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_unref0 (_tmp11_);
#line 137 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp12_) {
#line 138 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					result = prev_page;
#line 138 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_page_unref0 (p);
#line 138 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					return result;
#line 857 "book-view.c"
				}
#line 139 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp13_ = self->priv->page_data;
#line 139 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp14_ = p;
#line 139 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp15_ = g_hash_table_lookup (_tmp13_, _tmp14_);
#line 139 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp16_ = _page_view_ref0 ((PageView*) _tmp15_);
#line 139 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_view_unref0 (prev_page);
#line 139 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				prev_page = _tmp16_;
#line 132 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_unref0 (p);
#line 873 "book-view.c"
			}
		}
	}
#line 142 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp17_ = page;
#line 142 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp18_ = _page_view_ref0 (_tmp17_);
#line 142 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	result = _tmp18_;
#line 142 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_view_unref0 (prev_page);
#line 142 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 887 "book-view.c"
}


static void book_view_page_view_changed_cb (BookView* self, PageView* page) {
#line 145 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 145 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 147 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_redraw (self);
#line 898 "book-view.c"
}


static void book_view_page_view_size_changed_cb (BookView* self, PageView* page) {
#line 150 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 150 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 152 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 153 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_redraw (self);
#line 911 "book-view.c"
}


static void _book_view_page_view_changed_cb_page_view_changed (PageView* _sender, gpointer self) {
#line 159 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_page_view_changed_cb ((BookView*) self, _sender);
#line 918 "book-view.c"
}


static void _book_view_page_view_size_changed_cb_page_view_size_changed (PageView* _sender, gpointer self) {
#line 160 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_page_view_size_changed_cb ((BookView*) self, _sender);
#line 925 "book-view.c"
}


static gpointer _page_ref0 (gpointer self) {
#line 161 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return self ? page_ref (self) : NULL;
#line 932 "book-view.c"
}


static void book_view_add_cb (BookView* self, Book* book, Page* page) {
	PageView* page_view = NULL;
	Page* _tmp0_ = NULL;
	PageView* _tmp1_ = NULL;
	GHashTable* _tmp2_ = NULL;
	Page* _tmp3_ = NULL;
	Page* _tmp4_ = NULL;
	PageView* _tmp5_ = NULL;
#line 156 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 156 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 156 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 158 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = page;
#line 158 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = page_view_new (_tmp0_);
#line 158 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	page_view = _tmp1_;
#line 159 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (page_view, "changed", (GCallback) _book_view_page_view_changed_cb_page_view_changed, self, 0);
#line 160 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_connect_object (page_view, "size-changed", (GCallback) _book_view_page_view_size_changed_cb_page_view_size_changed, self, 0);
#line 161 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp2_ = self->priv->page_data;
#line 161 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp3_ = page;
#line 161 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp4_ = _page_ref0 (_tmp3_);
#line 161 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp5_ = _page_view_ref0 (page_view);
#line 161 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_hash_table_insert (_tmp2_, _tmp4_, _tmp5_);
#line 162 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 163 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_redraw (self);
#line 156 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_view_unref0 (page_view);
#line 976 "book-view.c"
}


static void book_view_set_selected_page (BookView* self, PageView* page) {
	gboolean _tmp0_ = FALSE;
	PageView* _tmp1_ = NULL;
	PageView* _tmp5_ = NULL;
	PageView* _tmp6_ = NULL;
	PageView* _tmp7_ = NULL;
	GtkWidget* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
#line 166 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 169 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = self->priv->selected_page;
#line 169 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp1_ != NULL) {
#line 995 "book-view.c"
		PageView* _tmp2_ = NULL;
		PageView* _tmp3_ = NULL;
#line 169 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp2_ = page;
#line 169 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp3_ = self->priv->selected_page;
#line 169 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp0_ = _tmp2_ != _tmp3_;
#line 1004 "book-view.c"
	} else {
#line 169 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp0_ = FALSE;
#line 1008 "book-view.c"
	}
#line 169 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp0_) {
#line 1012 "book-view.c"
		PageView* _tmp4_ = NULL;
#line 170 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp4_ = self->priv->selected_page;
#line 170 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		page_view_set_selected (_tmp4_, FALSE);
#line 1018 "book-view.c"
	}
#line 172 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp5_ = page;
#line 172 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp6_ = _page_view_ref0 (_tmp5_);
#line 172 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_view_unref0 (self->priv->selected_page);
#line 172 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->selected_page = _tmp6_;
#line 173 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp7_ = self->priv->selected_page;
#line 173 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp7_ == NULL) {
#line 174 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		return;
#line 1034 "book-view.c"
	}
#line 177 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp8_ = self->priv->drawing_area;
#line 177 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_object_get (_tmp8_, "has-focus", &_tmp9_, NULL);
#line 177 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp10_ = _tmp9_;
#line 177 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (!_tmp10_) {
#line 1044 "book-view.c"
		PageView* _tmp11_ = NULL;
#line 178 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp11_ = self->priv->selected_page;
#line 178 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		page_view_set_selected (_tmp11_, FALSE);
#line 1050 "book-view.c"
	} else {
		PageView* _tmp12_ = NULL;
#line 180 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp12_ = self->priv->selected_page;
#line 180 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		page_view_set_selected (_tmp12_, TRUE);
#line 1057 "book-view.c"
	}
}


static void book_view_set_x_offset (BookView* self, gint offset) {
	GtkAdjustment* _tmp0_ = NULL;
	gint _tmp1_ = 0;
#line 183 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 185 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->adjustment;
#line 185 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = offset;
#line 185 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gtk_adjustment_set_value (_tmp0_, (gdouble) _tmp1_);
#line 1073 "book-view.c"
}


static gint book_view_get_x_offset (BookView* self) {
	gint result = 0;
	GtkAdjustment* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
#line 188 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 190 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->adjustment;
#line 190 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
#line 190 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	result = (gint) _tmp1_;
#line 190 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 1091 "book-view.c"
}


static void book_view_show_page_view (BookView* self, PageView* page) {
	gboolean _tmp0_ = FALSE;
	PageView* _tmp1_ = NULL;
	GtkAllocation allocation = {0};
	GtkWidget* _tmp4_ = NULL;
	GtkAllocation _tmp5_ = {0};
	gint left_edge = 0;
	PageView* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint right_edge = 0;
	PageView* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	PageView* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
#line 193 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 195 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = page;
#line 195 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp1_ == NULL) {
#line 195 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp0_ = TRUE;
#line 1119 "book-view.c"
	} else {
		GtkScrollbar* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
#line 195 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp2_ = self->priv->scroll;
#line 195 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp3_ = gtk_widget_get_visible ((GtkWidget*) _tmp2_);
#line 195 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp0_ = !_tmp3_;
#line 1129 "book-view.c"
	}
#line 195 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp0_) {
#line 196 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		return;
#line 1135 "book-view.c"
	}
#line 199 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp4_ = self->priv->drawing_area;
#line 199 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gtk_widget_get_allocation (_tmp4_, &_tmp5_);
#line 199 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	allocation = _tmp5_;
#line 200 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp6_ = page;
#line 200 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp7_ = page_view_get_x_offset (_tmp6_);
#line 200 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	left_edge = _tmp7_;
#line 201 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp8_ = page;
#line 201 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp9_ = page_view_get_x_offset (_tmp8_);
#line 201 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp10_ = page;
#line 201 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp11_ = page_view_get_width (_tmp10_);
#line 201 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	right_edge = _tmp9_ + _tmp11_;
#line 203 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp12_ = left_edge;
#line 203 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp13_ = book_view_get_x_offset (self);
#line 203 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if ((_tmp12_ - _tmp13_) < 0) {
#line 1165 "book-view.c"
		gint _tmp14_ = 0;
#line 204 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp14_ = left_edge;
#line 204 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		book_view_set_x_offset (self, _tmp14_);
#line 1171 "book-view.c"
	} else {
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		GtkAllocation _tmp17_ = {0};
		gint _tmp18_ = 0;
#line 205 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp15_ = right_edge;
#line 205 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp16_ = book_view_get_x_offset (self);
#line 205 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp17_ = allocation;
#line 205 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp18_ = _tmp17_.width;
#line 205 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		if ((_tmp15_ - _tmp16_) > _tmp18_) {
#line 1187 "book-view.c"
			gint _tmp19_ = 0;
			GtkAllocation _tmp20_ = {0};
			gint _tmp21_ = 0;
#line 206 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp19_ = right_edge;
#line 206 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp20_ = allocation;
#line 206 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp21_ = _tmp20_.width;
#line 206 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			book_view_set_x_offset (self, _tmp19_ - _tmp21_);
#line 1199 "book-view.c"
		}
	}
}


static void book_view_select_page_view (BookView* self, PageView* page) {
	Page* p = NULL;
	PageView* _tmp0_ = NULL;
	PageView* _tmp1_ = NULL;
	PageView* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	PageView* _tmp5_ = NULL;
	Page* _tmp8_ = NULL;
#line 209 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 211 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	p = NULL;
#line 213 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->selected_page;
#line 213 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = page;
#line 213 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp0_ == _tmp1_) {
#line 214 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_page_unref0 (p);
#line 214 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		return;
#line 1227 "book-view.c"
	}
#line 216 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp2_ = page;
#line 216 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_set_selected_page (self, _tmp2_);
#line 218 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp3_ = self->priv->need_layout;
#line 218 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp3_) {
#line 219 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		self->priv->show_selected_page = TRUE;
#line 1239 "book-view.c"
	} else {
		PageView* _tmp4_ = NULL;
#line 221 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp4_ = page;
#line 221 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		book_view_show_page_view (self, _tmp4_);
#line 1246 "book-view.c"
	}
#line 223 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp5_ = page;
#line 223 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp5_ != NULL) {
#line 1252 "book-view.c"
		PageView* _tmp6_ = NULL;
		Page* _tmp7_ = NULL;
#line 224 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp6_ = page;
#line 224 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp7_ = page_view_get_page (_tmp6_);
#line 224 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_page_unref0 (p);
#line 224 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		p = _tmp7_;
#line 1263 "book-view.c"
	}
#line 225 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp8_ = p;
#line 225 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_emit_by_name (self, "page-selected", _tmp8_);
#line 209 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_unref0 (p);
#line 1271 "book-view.c"
}


static void book_view_remove_cb (BookView* self, Book* book, Page* page) {
	PageView* new_selection = NULL;
	PageView* _tmp0_ = NULL;
	PageView* _tmp1_ = NULL;
	Page* _tmp2_ = NULL;
	Page* _tmp3_ = NULL;
	Page* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	PageView* page_view = NULL;
	GHashTable* _tmp12_ = NULL;
	Page* _tmp13_ = NULL;
	gconstpointer _tmp14_ = NULL;
	PageView* _tmp15_ = NULL;
	guint _tmp16_ = 0U;
	guint _tmp17_ = 0U;
	GHashTable* _tmp18_ = NULL;
	Page* _tmp19_ = NULL;
	PageView* _tmp20_ = NULL;
#line 228 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 228 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 228 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 230 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->selected_page;
#line 230 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = _page_view_ref0 (_tmp0_);
#line 230 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	new_selection = _tmp1_;
#line 233 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp2_ = page;
#line 233 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp3_ = book_view_get_selected (self);
#line 233 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp4_ = _tmp3_;
#line 233 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp5_ = _tmp2_ == _tmp4_;
#line 233 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_unref0 (_tmp4_);
#line 233 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp5_) {
#line 1317 "book-view.c"
		PageView* _tmp6_ = NULL;
		PageView* _tmp7_ = NULL;
		PageView* _tmp8_ = NULL;
		PageView* _tmp9_ = NULL;
#line 235 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp6_ = self->priv->selected_page;
#line 235 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp7_ = book_view_get_prev_page (self, _tmp6_);
#line 235 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_page_view_unref0 (new_selection);
#line 235 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		new_selection = _tmp7_;
#line 236 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp8_ = new_selection;
#line 236 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp9_ = self->priv->selected_page;
#line 236 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		if (_tmp8_ == _tmp9_) {
#line 1336 "book-view.c"
			PageView* _tmp10_ = NULL;
			PageView* _tmp11_ = NULL;
#line 237 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp10_ = self->priv->selected_page;
#line 237 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp11_ = book_view_get_next_page (self, _tmp10_);
#line 237 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_page_view_unref0 (new_selection);
#line 237 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			new_selection = _tmp11_;
#line 1347 "book-view.c"
		}
#line 238 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_page_view_unref0 (self->priv->selected_page);
#line 238 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		self->priv->selected_page = NULL;
#line 1353 "book-view.c"
	}
#line 241 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp12_ = self->priv->page_data;
#line 241 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp13_ = page;
#line 241 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp14_ = g_hash_table_lookup (_tmp12_, _tmp13_);
#line 241 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp15_ = _page_view_ref0 ((PageView*) _tmp14_);
#line 241 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	page_view = _tmp15_;
#line 242 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("changed", TYPE_PAGE_VIEW, &_tmp16_, NULL, FALSE);
#line 242 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (page_view, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _book_view_page_view_changed_cb_page_view_changed, self);
#line 243 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("size-changed", TYPE_PAGE_VIEW, &_tmp17_, NULL, FALSE);
#line 243 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (page_view, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _book_view_page_view_size_changed_cb_page_view_size_changed, self);
#line 244 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp18_ = self->priv->page_data;
#line 244 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp19_ = page;
#line 244 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_hash_table_remove (_tmp18_, _tmp19_);
#line 246 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp20_ = new_selection;
#line 246 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_select_page_view (self, _tmp20_);
#line 248 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 249 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_redraw (self);
#line 228 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_view_unref0 (page_view);
#line 228 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_view_unref0 (new_selection);
#line 1391 "book-view.c"
}


static void book_view_reorder_cb (BookView* self, Book* book) {
#line 252 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 252 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 254 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 255 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_redraw (self);
#line 1404 "book-view.c"
}


static void book_view_clear_cb (BookView* self, Book* book) {
	GHashTable* _tmp0_ = NULL;
#line 258 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 258 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 260 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->page_data;
#line 260 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_hash_table_remove_all (_tmp0_);
#line 261 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_view_unref0 (self->priv->selected_page);
#line 261 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->selected_page = NULL;
#line 262 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_emit_by_name (self, "page-selected", NULL);
#line 263 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 264 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_redraw (self);
#line 1428 "book-view.c"
}


Book* book_view_get_book (BookView* self) {
	Book* result = NULL;
	Book* _tmp0_ = NULL;
	Book* _tmp1_ = NULL;
#line 267 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 269 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->book;
#line 269 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = _book_ref0 (_tmp0_);
#line 269 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	result = _tmp1_;
#line 269 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 1446 "book-view.c"
}


static gboolean book_view_configure_cb (BookView* self, GtkWidget* widget, GdkEventConfigure* event) {
	gboolean result = FALSE;
#line 272 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 272 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 272 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 274 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 275 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	result = FALSE;
#line 275 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 1464 "book-view.c"
}


static void book_view_layout_into (BookView* self, gint width, gint height, gint* book_width, gint* book_height) {
	gint _vala_book_width = 0;
	gint _vala_book_height = 0;
	gint max_dpi = 0;
	gint max_width = 0;
	gint max_height = 0;
	gdouble aspect = 0.0;
	gint _tmp39_ = 0;
	gint _tmp40_ = 0;
	gdouble max_aspect = 0.0;
	gint _tmp41_ = 0;
	gint _tmp42_ = 0;
	gint spacing = 0;
	gint x_offset = 0;
#line 278 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 281 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	max_dpi = 0;
#line 1486 "book-view.c"
	{
		gint i = 0;
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		i = 0;
#line 1491 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp0_ = TRUE;
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			while (TRUE) {
#line 1498 "book-view.c"
				gint _tmp2_ = 0;
				Book* _tmp3_ = NULL;
				guint _tmp4_ = 0U;
				Page* page = NULL;
				Book* _tmp5_ = NULL;
				gint _tmp6_ = 0;
				Page* _tmp7_ = NULL;
				Page* _tmp8_ = NULL;
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!_tmp0_) {
#line 1511 "book-view.c"
					gint _tmp1_ = 0;
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp1_ = i;
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					i = _tmp1_ + 1;
#line 1517 "book-view.c"
				}
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp0_ = FALSE;
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp2_ = i;
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp3_ = self->priv->book;
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp4_ = book_get_n_pages (_tmp3_);
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!(((guint) _tmp2_) < _tmp4_)) {
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					break;
#line 1531 "book-view.c"
				}
#line 284 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp5_ = self->priv->book;
#line 284 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp6_ = i;
#line 284 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp7_ = book_get_page (_tmp5_, _tmp6_);
#line 284 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				page = _tmp7_;
#line 285 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp8_ = page;
#line 285 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp9_ = page_get_dpi (_tmp8_);
#line 285 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp10_ = max_dpi;
#line 285 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp9_ > _tmp10_) {
#line 1549 "book-view.c"
					Page* _tmp11_ = NULL;
					gint _tmp12_ = 0;
#line 286 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp11_ = page;
#line 286 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp12_ = page_get_dpi (_tmp11_);
#line 286 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					max_dpi = _tmp12_;
#line 1558 "book-view.c"
				}
#line 282 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_unref0 (page);
#line 1562 "book-view.c"
			}
		}
	}
#line 290 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	max_width = 0;
#line 290 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	max_height = 0;
#line 1570 "book-view.c"
	{
		gint i = 0;
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		i = 0;
#line 1575 "book-view.c"
		{
			gboolean _tmp13_ = FALSE;
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp13_ = TRUE;
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			while (TRUE) {
#line 1582 "book-view.c"
				gint _tmp15_ = 0;
				Book* _tmp16_ = NULL;
				guint _tmp17_ = 0U;
				Page* page = NULL;
				Book* _tmp18_ = NULL;
				gint _tmp19_ = 0;
				Page* _tmp20_ = NULL;
				gint w = 0;
				Page* _tmp21_ = NULL;
				gint _tmp22_ = 0;
				gint h = 0;
				Page* _tmp23_ = NULL;
				gint _tmp24_ = 0;
				gint _tmp25_ = 0;
				gint _tmp26_ = 0;
				Page* _tmp27_ = NULL;
				gint _tmp28_ = 0;
				gint _tmp29_ = 0;
				gint _tmp30_ = 0;
				Page* _tmp31_ = NULL;
				gint _tmp32_ = 0;
				gint _tmp33_ = 0;
				gint _tmp34_ = 0;
				gint _tmp36_ = 0;
				gint _tmp37_ = 0;
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!_tmp13_) {
#line 1610 "book-view.c"
					gint _tmp14_ = 0;
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp14_ = i;
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					i = _tmp14_ + 1;
#line 1616 "book-view.c"
				}
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp13_ = FALSE;
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp15_ = i;
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp16_ = self->priv->book;
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp17_ = book_get_n_pages (_tmp16_);
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!(((guint) _tmp15_) < _tmp17_)) {
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					break;
#line 1630 "book-view.c"
				}
#line 293 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp18_ = self->priv->book;
#line 293 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp19_ = i;
#line 293 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp20_ = book_get_page (_tmp18_, _tmp19_);
#line 293 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				page = _tmp20_;
#line 294 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp21_ = page;
#line 294 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp22_ = page_get_width (_tmp21_);
#line 294 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				w = _tmp22_;
#line 295 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp23_ = page;
#line 295 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp24_ = page_get_height (_tmp23_);
#line 295 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				h = _tmp24_;
#line 298 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp25_ = w;
#line 298 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp26_ = max_dpi;
#line 298 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp27_ = page;
#line 298 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp28_ = page_get_dpi (_tmp27_);
#line 298 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				w = (gint) (((((gdouble) _tmp25_) * _tmp26_) / _tmp28_) + 0.5);
#line 299 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp29_ = h;
#line 299 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp30_ = max_dpi;
#line 299 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp31_ = page;
#line 299 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp32_ = page_get_dpi (_tmp31_);
#line 299 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				h = (gint) (((((gdouble) _tmp29_) * _tmp30_) / _tmp32_) + 0.5);
#line 301 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp33_ = w;
#line 301 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp34_ = max_width;
#line 301 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp33_ > _tmp34_) {
#line 1678 "book-view.c"
					gint _tmp35_ = 0;
#line 302 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp35_ = w;
#line 302 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					max_width = _tmp35_;
#line 1684 "book-view.c"
				}
#line 303 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp36_ = h;
#line 303 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp37_ = max_height;
#line 303 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp36_ > _tmp37_) {
#line 1692 "book-view.c"
					gint _tmp38_ = 0;
#line 304 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp38_ = h;
#line 304 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					max_height = _tmp38_;
#line 1698 "book-view.c"
				}
#line 291 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_unref0 (page);
#line 1702 "book-view.c"
			}
		}
	}
#line 307 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp39_ = width;
#line 307 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp40_ = height;
#line 307 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	aspect = ((gdouble) _tmp39_) / _tmp40_;
#line 308 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp41_ = max_width;
#line 308 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp42_ = max_height;
#line 308 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	max_aspect = ((gdouble) _tmp41_) / _tmp42_;
#line 311 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	spacing = 12;
#line 312 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_vala_book_width = 0;
#line 313 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_vala_book_height = 0;
#line 1724 "book-view.c"
	{
		gint i = 0;
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		i = 0;
#line 1729 "book-view.c"
		{
			gboolean _tmp43_ = FALSE;
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp43_ = TRUE;
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			while (TRUE) {
#line 1736 "book-view.c"
				gint _tmp45_ = 0;
				Book* _tmp46_ = NULL;
				guint _tmp47_ = 0U;
				PageView* page = NULL;
				gint _tmp48_ = 0;
				PageView* _tmp49_ = NULL;
				Page* p = NULL;
				PageView* _tmp50_ = NULL;
				Page* _tmp51_ = NULL;
				gdouble _tmp52_ = 0.0;
				gdouble _tmp53_ = 0.0;
				gint h = 0;
				PageView* _tmp72_ = NULL;
				gint _tmp73_ = 0;
				gint _tmp74_ = 0;
				gint _tmp75_ = 0;
				gint _tmp77_ = 0;
				PageView* _tmp78_ = NULL;
				gint _tmp79_ = 0;
				gint _tmp80_ = 0;
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!_tmp43_) {
#line 1759 "book-view.c"
					gint _tmp44_ = 0;
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp44_ = i;
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					i = _tmp44_ + 1;
#line 1765 "book-view.c"
				}
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp43_ = FALSE;
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp45_ = i;
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp46_ = self->priv->book;
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp47_ = book_get_n_pages (_tmp46_);
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!(((guint) _tmp45_) < _tmp47_)) {
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					break;
#line 1779 "book-view.c"
				}
#line 316 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp48_ = i;
#line 316 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp49_ = book_view_get_nth_page (self, _tmp48_);
#line 316 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				page = _tmp49_;
#line 317 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp50_ = page;
#line 317 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp51_ = page_view_get_page (_tmp50_);
#line 317 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				p = _tmp51_;
#line 320 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp52_ = max_aspect;
#line 320 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp53_ = aspect;
#line 320 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp52_ > _tmp53_) {
#line 1799 "book-view.c"
					gint w = 0;
					Page* _tmp54_ = NULL;
					gint _tmp55_ = 0;
					gint _tmp56_ = 0;
					gint _tmp57_ = 0;
					Page* _tmp58_ = NULL;
					gint _tmp59_ = 0;
					gint _tmp60_ = 0;
					PageView* _tmp61_ = NULL;
					gint _tmp62_ = 0;
#line 323 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp54_ = p;
#line 323 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp55_ = page_get_width (_tmp54_);
#line 323 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp56_ = max_dpi;
#line 323 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp57_ = width;
#line 323 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp58_ = p;
#line 323 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp59_ = page_get_dpi (_tmp58_);
#line 323 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp60_ = max_width;
#line 323 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					w = (gint) (((((gdouble) _tmp55_) * _tmp56_) * _tmp57_) / (_tmp59_ * _tmp60_));
#line 324 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp61_ = page;
#line 324 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp62_ = w;
#line 324 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					page_view_set_width (_tmp61_, _tmp62_);
#line 1832 "book-view.c"
				} else {
					gint h = 0;
					Page* _tmp63_ = NULL;
					gint _tmp64_ = 0;
					gint _tmp65_ = 0;
					gint _tmp66_ = 0;
					Page* _tmp67_ = NULL;
					gint _tmp68_ = 0;
					gint _tmp69_ = 0;
					PageView* _tmp70_ = NULL;
					gint _tmp71_ = 0;
#line 329 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp63_ = p;
#line 329 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp64_ = page_get_height (_tmp63_);
#line 329 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp65_ = max_dpi;
#line 329 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp66_ = height;
#line 329 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp67_ = p;
#line 329 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp68_ = page_get_dpi (_tmp67_);
#line 329 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp69_ = max_height;
#line 329 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					h = (gint) (((((gdouble) _tmp64_) * _tmp65_) * _tmp66_) / (_tmp68_ * _tmp69_));
#line 330 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp70_ = page;
#line 330 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp71_ = h;
#line 330 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					page_view_set_height (_tmp70_, _tmp71_);
#line 1866 "book-view.c"
				}
#line 333 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp72_ = page;
#line 333 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp73_ = page_view_get_height (_tmp72_);
#line 333 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				h = _tmp73_;
#line 334 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp74_ = h;
#line 334 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp75_ = _vala_book_height;
#line 334 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp74_ > _tmp75_) {
#line 1880 "book-view.c"
					gint _tmp76_ = 0;
#line 335 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp76_ = h;
#line 335 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_vala_book_height = _tmp76_;
#line 1886 "book-view.c"
				}
#line 336 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp77_ = _vala_book_width;
#line 336 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp78_ = page;
#line 336 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp79_ = page_view_get_width (_tmp78_);
#line 336 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_vala_book_width = _tmp77_ + _tmp79_;
#line 337 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp80_ = i;
#line 337 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp80_ != 0) {
#line 1900 "book-view.c"
					gint _tmp81_ = 0;
					gint _tmp82_ = 0;
#line 338 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp81_ = _vala_book_width;
#line 338 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp82_ = spacing;
#line 338 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_vala_book_width = _tmp81_ + _tmp82_;
#line 1909 "book-view.c"
				}
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_unref0 (p);
#line 314 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_view_unref0 (page);
#line 1915 "book-view.c"
			}
		}
	}
#line 341 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	x_offset = 0;
#line 1921 "book-view.c"
	{
		gint i = 0;
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		i = 0;
#line 1926 "book-view.c"
		{
			gboolean _tmp83_ = FALSE;
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp83_ = TRUE;
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			while (TRUE) {
#line 1933 "book-view.c"
				gint _tmp85_ = 0;
				Book* _tmp86_ = NULL;
				guint _tmp87_ = 0U;
				PageView* page = NULL;
				gint _tmp88_ = 0;
				PageView* _tmp89_ = NULL;
				PageView* _tmp90_ = NULL;
				gint _tmp91_ = 0;
				gint _tmp92_ = 0;
				PageView* _tmp93_ = NULL;
				gint _tmp94_ = 0;
				gint _tmp95_ = 0;
				PageView* _tmp96_ = NULL;
				gint _tmp97_ = 0;
				PageView* _tmp98_ = NULL;
				gint _tmp99_ = 0;
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!_tmp83_) {
#line 1952 "book-view.c"
					gint _tmp84_ = 0;
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp84_ = i;
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					i = _tmp84_ + 1;
#line 1958 "book-view.c"
				}
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp83_ = FALSE;
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp85_ = i;
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp86_ = self->priv->book;
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp87_ = book_get_n_pages (_tmp86_);
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!(((guint) _tmp85_) < _tmp87_)) {
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					break;
#line 1972 "book-view.c"
				}
#line 344 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp88_ = i;
#line 344 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp89_ = book_view_get_nth_page (self, _tmp88_);
#line 344 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				page = _tmp89_;
#line 347 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp90_ = page;
#line 347 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp91_ = x_offset;
#line 347 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				page_view_set_x_offset (_tmp90_, _tmp91_);
#line 348 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp92_ = x_offset;
#line 348 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp93_ = page;
#line 348 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp94_ = page_view_get_width (_tmp93_);
#line 348 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp95_ = spacing;
#line 348 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				x_offset = _tmp92_ + (_tmp94_ + _tmp95_);
#line 351 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp96_ = page;
#line 351 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp97_ = height;
#line 351 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp98_ = page;
#line 351 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp99_ = page_view_get_height (_tmp98_);
#line 351 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				page_view_set_y_offset (_tmp96_, (_tmp97_ - _tmp99_) / 2);
#line 342 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_view_unref0 (page);
#line 2008 "book-view.c"
			}
		}
	}
#line 278 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (book_width) {
#line 278 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		*book_width = _vala_book_width;
#line 2016 "book-view.c"
	}
#line 278 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (book_height) {
#line 278 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		*book_height = _vala_book_height;
#line 2022 "book-view.c"
	}
}


static void book_view_layout (BookView* self) {
	gboolean _tmp0_ = FALSE;
	GtkAllocation allocation = {0};
	GtkWidget* _tmp1_ = NULL;
	GtkAllocation _tmp2_ = {0};
	GtkAllocation box_allocation = {0};
	GtkAllocation _tmp3_ = {0};
	gboolean right_aligned = FALSE;
	GtkAdjustment* _tmp4_ = NULL;
	gdouble _tmp5_ = 0.0;
	GtkAdjustment* _tmp6_ = NULL;
	gdouble _tmp7_ = 0.0;
	GtkAdjustment* _tmp8_ = NULL;
	gdouble _tmp9_ = 0.0;
	gint width = 0;
	GtkAllocation _tmp10_ = {0};
	gint _tmp11_ = 0;
	gint height = 0;
	GtkAllocation _tmp12_ = {0};
	gint _tmp13_ = 0;
	guint _tmp14_ = 0U;
	gint book_width = 0;
	gint book_height = 0;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	GtkAllocation _tmp20_ = {0};
	gint _tmp21_ = 0;
	gboolean _tmp53_ = FALSE;
#line 355 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 357 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->need_layout;
#line 357 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (!_tmp0_) {
#line 358 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		return;
#line 2066 "book-view.c"
	}
#line 360 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->laying_out = TRUE;
#line 363 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = self->priv->drawing_area;
#line 363 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gtk_widget_get_allocation (_tmp1_, &_tmp2_);
#line 363 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	allocation = _tmp2_;
#line 365 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp3_);
#line 365 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	box_allocation = _tmp3_;
#line 368 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	right_aligned = TRUE;
#line 369 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp4_ = self->priv->adjustment;
#line 369 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp5_ = gtk_adjustment_get_value (_tmp4_);
#line 369 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp6_ = self->priv->adjustment;
#line 369 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp7_ = gtk_adjustment_get_upper (_tmp6_);
#line 369 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp8_ = self->priv->adjustment;
#line 369 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp9_ = gtk_adjustment_get_page_size (_tmp8_);
#line 369 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp5_ < (_tmp7_ - _tmp9_)) {
#line 370 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		right_aligned = FALSE;
#line 2098 "book-view.c"
	}
#line 373 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp10_ = allocation;
#line 373 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp11_ = _tmp10_.width;
#line 373 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	width = (gint) _tmp11_;
#line 374 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp12_ = box_allocation;
#line 374 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp13_ = _tmp12_.height;
#line 374 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp14_ = gtk_container_get_border_width ((GtkContainer*) self);
#line 374 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	height = (gint) (_tmp13_ - (_tmp14_ * 2));
#line 376 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp15_ = width;
#line 376 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp16_ = height;
#line 376 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_layout_into (self, _tmp15_, _tmp16_, &_tmp17_, &_tmp18_);
#line 376 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_width = _tmp17_;
#line 376 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_height = _tmp18_;
#line 379 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp19_ = book_width;
#line 379 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp20_ = allocation;
#line 379 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp21_ = _tmp20_.width;
#line 379 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp19_ > _tmp21_) {
#line 2132 "book-view.c"
		GtkAllocation _tmp22_ = {0};
		gint _tmp23_ = 0;
		gint _tmp24_ = 0;
		gint _tmp25_ = 0;
		gint _tmp26_ = 0;
		gint _tmp27_ = 0;
		GtkAdjustment* _tmp28_ = NULL;
		GtkAdjustment* _tmp29_ = NULL;
		gint _tmp30_ = 0;
		GtkAdjustment* _tmp31_ = NULL;
		GtkAllocation _tmp32_ = {0};
		gint _tmp33_ = 0;
		gint max_offset = 0;
		gint _tmp34_ = 0;
		GtkAllocation _tmp35_ = {0};
		gint _tmp36_ = 0;
		gboolean _tmp37_ = FALSE;
		gboolean _tmp38_ = FALSE;
		GtkScrollbar* _tmp42_ = NULL;
#line 382 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp22_ = allocation;
#line 382 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp23_ = _tmp22_.height;
#line 382 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		height = _tmp23_;
#line 383 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp24_ = width;
#line 383 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp25_ = height;
#line 383 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		book_view_layout_into (self, _tmp24_, _tmp25_, &_tmp26_, &_tmp27_);
#line 383 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		book_width = _tmp26_;
#line 383 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		book_height = _tmp27_;
#line 386 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp28_ = self->priv->adjustment;
#line 386 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		gtk_adjustment_set_lower (_tmp28_, (gdouble) 0);
#line 387 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp29_ = self->priv->adjustment;
#line 387 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp30_ = book_width;
#line 387 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		gtk_adjustment_set_upper (_tmp29_, (gdouble) _tmp30_);
#line 388 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp31_ = self->priv->adjustment;
#line 388 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp32_ = allocation;
#line 388 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp33_ = _tmp32_.width;
#line 388 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		gtk_adjustment_set_page_size (_tmp31_, (gdouble) _tmp33_);
#line 391 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp34_ = book_width;
#line 391 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp35_ = allocation;
#line 391 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp36_ = _tmp35_.width;
#line 391 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		max_offset = _tmp34_ - _tmp36_;
#line 392 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp38_ = right_aligned;
#line 392 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		if (_tmp38_) {
#line 392 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp37_ = TRUE;
#line 2200 "book-view.c"
		} else {
			gint _tmp39_ = 0;
			gint _tmp40_ = 0;
#line 392 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp39_ = book_view_get_x_offset (self);
#line 392 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp40_ = max_offset;
#line 392 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp37_ = _tmp39_ > _tmp40_;
#line 2210 "book-view.c"
		}
#line 392 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		if (_tmp37_) {
#line 2214 "book-view.c"
			gint _tmp41_ = 0;
#line 393 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp41_ = max_offset;
#line 393 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			book_view_set_x_offset (self, _tmp41_);
#line 2220 "book-view.c"
		}
#line 395 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp42_ = self->priv->scroll;
#line 395 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		gtk_widget_show ((GtkWidget*) _tmp42_);
#line 2226 "book-view.c"
	} else {
		GtkScrollbar* _tmp43_ = NULL;
		gint offset = 0;
		gint _tmp44_ = 0;
		GtkAllocation _tmp45_ = {0};
		gint _tmp46_ = 0;
		GtkAdjustment* _tmp47_ = NULL;
		gint _tmp48_ = 0;
		GtkAdjustment* _tmp49_ = NULL;
		gint _tmp50_ = 0;
		GtkAdjustment* _tmp51_ = NULL;
		gint _tmp52_ = 0;
#line 399 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp43_ = self->priv->scroll;
#line 399 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp43_);
#line 400 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp44_ = book_width;
#line 400 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp45_ = allocation;
#line 400 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp46_ = _tmp45_.width;
#line 400 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		offset = (_tmp44_ - _tmp46_) / 2;
#line 401 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp47_ = self->priv->adjustment;
#line 401 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp48_ = offset;
#line 401 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		gtk_adjustment_set_lower (_tmp47_, (gdouble) _tmp48_);
#line 402 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp49_ = self->priv->adjustment;
#line 402 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp50_ = offset;
#line 402 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		gtk_adjustment_set_upper (_tmp49_, (gdouble) _tmp50_);
#line 403 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp51_ = self->priv->adjustment;
#line 403 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		gtk_adjustment_set_page_size (_tmp51_, (gdouble) 0);
#line 404 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp52_ = offset;
#line 404 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		book_view_set_x_offset (self, _tmp52_);
#line 2271 "book-view.c"
	}
#line 407 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp53_ = self->priv->show_selected_page;
#line 407 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp53_) {
#line 2277 "book-view.c"
		PageView* _tmp54_ = NULL;
#line 408 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp54_ = self->priv->selected_page;
#line 408 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		book_view_show_page_view (self, _tmp54_);
#line 2283 "book-view.c"
	}
#line 410 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->need_layout = FALSE;
#line 411 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->show_selected_page = FALSE;
#line 412 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->laying_out = FALSE;
#line 2291 "book-view.c"
}


static gboolean book_view_draw_cb (BookView* self, GtkWidget* widget, cairo_t* context) {
	gboolean result = FALSE;
	Book* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	gdouble left = 0.0;
	gdouble top = 0.0;
	gdouble right = 0.0;
	gdouble bottom = 0.0;
	cairo_t* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
#line 415 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 415 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 415 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 417 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->book;
#line 417 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = book_get_n_pages (_tmp0_);
#line 417 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp1_ == ((guint) 0)) {
#line 418 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		result = FALSE;
#line 418 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		return result;
#line 2324 "book-view.c"
	}
#line 420 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_layout (self);
#line 423 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp2_ = context;
#line 423 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	cairo_clip_extents (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 423 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	left = _tmp3_;
#line 423 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	top = _tmp4_;
#line 423 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	right = _tmp5_;
#line 423 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	bottom = _tmp6_;
#line 2340 "book-view.c"
	{
		gint i = 0;
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		i = 0;
#line 2345 "book-view.c"
		{
			gboolean _tmp7_ = FALSE;
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp7_ = TRUE;
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			while (TRUE) {
#line 2352 "book-view.c"
				gint _tmp9_ = 0;
				Book* _tmp10_ = NULL;
				guint _tmp11_ = 0U;
				PageView* page = NULL;
				gint _tmp12_ = 0;
				PageView* _tmp13_ = NULL;
				gint left_edge = 0;
				PageView* _tmp14_ = NULL;
				gint _tmp15_ = 0;
				gint _tmp16_ = 0;
				gint right_edge = 0;
				PageView* _tmp17_ = NULL;
				gint _tmp18_ = 0;
				PageView* _tmp19_ = NULL;
				gint _tmp20_ = 0;
				gint _tmp21_ = 0;
				gboolean _tmp22_ = FALSE;
				gint _tmp23_ = 0;
				gdouble _tmp24_ = 0.0;
				cairo_t* _tmp27_ = NULL;
				cairo_t* _tmp28_ = NULL;
				gint _tmp29_ = 0;
				PageView* _tmp30_ = NULL;
				cairo_t* _tmp31_ = NULL;
				cairo_t* _tmp32_ = NULL;
				PageView* _tmp33_ = NULL;
				gboolean _tmp34_ = FALSE;
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!_tmp7_) {
#line 2382 "book-view.c"
					gint _tmp8_ = 0;
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp8_ = i;
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					i = _tmp8_ + 1;
#line 2388 "book-view.c"
				}
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp7_ = FALSE;
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp9_ = i;
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp10_ = self->priv->book;
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp11_ = book_get_n_pages (_tmp10_);
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!(((guint) _tmp9_) < _tmp11_)) {
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					break;
#line 2402 "book-view.c"
				}
#line 428 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp12_ = i;
#line 428 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp13_ = book_view_get_nth_page (self, _tmp12_);
#line 428 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				page = _tmp13_;
#line 429 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp14_ = page;
#line 429 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp15_ = page_view_get_x_offset (_tmp14_);
#line 429 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp16_ = book_view_get_x_offset (self);
#line 429 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				left_edge = _tmp15_ - _tmp16_;
#line 430 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp17_ = page;
#line 430 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp18_ = page_view_get_x_offset (_tmp17_);
#line 430 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp19_ = page;
#line 430 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp20_ = page_view_get_width (_tmp19_);
#line 430 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp21_ = book_view_get_x_offset (self);
#line 430 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				right_edge = (_tmp18_ + _tmp20_) - _tmp21_;
#line 433 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp23_ = right_edge;
#line 433 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp24_ = left;
#line 433 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (((gdouble) _tmp23_) < _tmp24_) {
#line 433 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp22_ = TRUE;
#line 2438 "book-view.c"
				} else {
					gint _tmp25_ = 0;
					gdouble _tmp26_ = 0.0;
#line 433 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp25_ = left_edge;
#line 433 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp26_ = right;
#line 433 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp22_ = ((gdouble) _tmp25_) > _tmp26_;
#line 2448 "book-view.c"
				}
#line 433 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp22_) {
#line 434 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_page_view_unref0 (page);
#line 434 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					continue;
#line 2456 "book-view.c"
				}
#line 436 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp27_ = context;
#line 436 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				cairo_save (_tmp27_);
#line 437 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp28_ = context;
#line 437 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp29_ = book_view_get_x_offset (self);
#line 437 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				cairo_translate (_tmp28_, (gdouble) (-_tmp29_), (gdouble) 0);
#line 438 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp30_ = page;
#line 438 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp31_ = context;
#line 438 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				page_view_render (_tmp30_, _tmp31_);
#line 439 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp32_ = context;
#line 439 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				cairo_restore (_tmp32_);
#line 441 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp33_ = page;
#line 441 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp34_ = page_view_get_selected (_tmp33_);
#line 441 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp34_) {
#line 2484 "book-view.c"
					GtkWidget* _tmp35_ = NULL;
					GtkStyleContext* _tmp36_ = NULL;
					cairo_t* _tmp37_ = NULL;
					PageView* _tmp38_ = NULL;
					gint _tmp39_ = 0;
					gint _tmp40_ = 0;
					PageView* _tmp41_ = NULL;
					gint _tmp42_ = 0;
					PageView* _tmp43_ = NULL;
					gint _tmp44_ = 0;
					PageView* _tmp45_ = NULL;
					gint _tmp46_ = 0;
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp35_ = self->priv->drawing_area;
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp36_ = gtk_widget_get_style_context (_tmp35_);
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp37_ = context;
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp38_ = page;
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp39_ = page_view_get_x_offset (_tmp38_);
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp40_ = book_view_get_x_offset (self);
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp41_ = page;
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp42_ = page_view_get_y_offset (_tmp41_);
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp43_ = page;
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp44_ = page_view_get_width (_tmp43_);
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp45_ = page;
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp46_ = page_view_get_height (_tmp45_);
#line 442 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					gtk_render_focus (_tmp36_, _tmp37_, (gdouble) (_tmp39_ - _tmp40_), (gdouble) _tmp42_, (gdouble) _tmp44_, (gdouble) _tmp46_);
#line 2523 "book-view.c"
				}
#line 426 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_view_unref0 (page);
#line 2527 "book-view.c"
			}
		}
	}
#line 449 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	result = FALSE;
#line 449 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 2535 "book-view.c"
}


static PageView* book_view_get_page_at (BookView* self, gint x, gint y, gint* x_, gint* y_) {
	gint _vala_x_ = 0;
	gint _vala_y_ = 0;
	PageView* result = NULL;
	gint _tmp0_ = 0;
#line 452 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 454 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_vala_y_ = 0;
#line 454 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = _vala_y_;
#line 454 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_vala_x_ = _tmp0_;
#line 2552 "book-view.c"
	{
		gint i = 0;
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		i = 0;
#line 2557 "book-view.c"
		{
			gboolean _tmp1_ = FALSE;
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp1_ = TRUE;
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			while (TRUE) {
#line 2564 "book-view.c"
				gint _tmp3_ = 0;
				Book* _tmp4_ = NULL;
				guint _tmp5_ = 0U;
				PageView* page = NULL;
				gint _tmp6_ = 0;
				PageView* _tmp7_ = NULL;
				gint left = 0;
				PageView* _tmp8_ = NULL;
				gint _tmp9_ = 0;
				gint right = 0;
				gint _tmp10_ = 0;
				PageView* _tmp11_ = NULL;
				gint _tmp12_ = 0;
				gint top = 0;
				PageView* _tmp13_ = NULL;
				gint _tmp14_ = 0;
				gint bottom = 0;
				gint _tmp15_ = 0;
				PageView* _tmp16_ = NULL;
				gint _tmp17_ = 0;
				gboolean _tmp18_ = FALSE;
				gboolean _tmp19_ = FALSE;
				gboolean _tmp20_ = FALSE;
				gint _tmp21_ = 0;
				gint _tmp22_ = 0;
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!_tmp1_) {
#line 2592 "book-view.c"
					gint _tmp2_ = 0;
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp2_ = i;
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					i = _tmp2_ + 1;
#line 2598 "book-view.c"
				}
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp1_ = FALSE;
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp3_ = i;
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp4_ = self->priv->book;
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp5_ = book_get_n_pages (_tmp4_);
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (!(((guint) _tmp3_) < _tmp5_)) {
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					break;
#line 2612 "book-view.c"
				}
#line 457 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp6_ = i;
#line 457 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp7_ = book_view_get_nth_page (self, _tmp6_);
#line 457 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				page = _tmp7_;
#line 458 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp8_ = page;
#line 458 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp9_ = page_view_get_x_offset (_tmp8_);
#line 458 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				left = _tmp9_;
#line 459 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp10_ = left;
#line 459 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp11_ = page;
#line 459 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp12_ = page_view_get_width (_tmp11_);
#line 459 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				right = _tmp10_ + _tmp12_;
#line 460 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp13_ = page;
#line 460 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp14_ = page_view_get_y_offset (_tmp13_);
#line 460 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				top = _tmp14_;
#line 461 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp15_ = top;
#line 461 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp16_ = page;
#line 461 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp17_ = page_view_get_height (_tmp16_);
#line 461 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				bottom = _tmp15_ + _tmp17_;
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp21_ = x;
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp22_ = left;
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp21_ >= _tmp22_) {
#line 2654 "book-view.c"
					gint _tmp23_ = 0;
					gint _tmp24_ = 0;
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp23_ = x;
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp24_ = right;
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp20_ = _tmp23_ <= _tmp24_;
#line 2663 "book-view.c"
				} else {
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp20_ = FALSE;
#line 2667 "book-view.c"
				}
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp20_) {
#line 2671 "book-view.c"
					gint _tmp25_ = 0;
					gint _tmp26_ = 0;
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp25_ = y;
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp26_ = top;
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp19_ = _tmp25_ >= _tmp26_;
#line 2680 "book-view.c"
				} else {
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp19_ = FALSE;
#line 2684 "book-view.c"
				}
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp19_) {
#line 2688 "book-view.c"
					gint _tmp27_ = 0;
					gint _tmp28_ = 0;
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp27_ = y;
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp28_ = bottom;
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp18_ = _tmp27_ <= _tmp28_;
#line 2697 "book-view.c"
				} else {
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp18_ = FALSE;
#line 2701 "book-view.c"
				}
#line 462 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp18_) {
#line 2705 "book-view.c"
					gint _tmp29_ = 0;
					gint _tmp30_ = 0;
					gint _tmp31_ = 0;
					gint _tmp32_ = 0;
#line 464 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp29_ = x;
#line 464 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp30_ = left;
#line 464 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_vala_x_ = _tmp29_ - _tmp30_;
#line 465 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp31_ = y;
#line 465 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp32_ = top;
#line 465 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_vala_y_ = _tmp31_ - _tmp32_;
#line 466 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					result = page;
#line 466 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					if (x_) {
#line 466 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
						*x_ = _vala_x_;
#line 2728 "book-view.c"
					}
#line 466 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					if (y_) {
#line 466 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
						*y_ = _vala_y_;
#line 2734 "book-view.c"
					}
#line 466 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					return result;
#line 2738 "book-view.c"
				}
#line 455 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_page_view_unref0 (page);
#line 2742 "book-view.c"
			}
		}
	}
#line 470 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	result = NULL;
#line 470 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (x_) {
#line 470 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		*x_ = _vala_x_;
#line 2752 "book-view.c"
	}
#line 470 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (y_) {
#line 470 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		*y_ = _vala_y_;
#line 2758 "book-view.c"
	}
#line 470 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 2762 "book-view.c"
}


static gboolean book_view_button_cb (BookView* self, GtkWidget* widget, GdkEventButton* event) {
	gboolean result = FALSE;
	GtkWidget* _tmp0_ = NULL;
	gint x = 0;
	gint y = 0;
	GdkEventButton* _tmp1_ = NULL;
	GdkEventType _tmp2_ = 0;
	PageView* _tmp12_ = NULL;
	GdkEventButton* _tmp13_ = NULL;
	guint _tmp14_ = 0U;
	GdkEventButton* _tmp29_ = NULL;
	guint _tmp30_ = 0U;
#line 473 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 473 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 473 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 475 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_layout (self);
#line 477 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->drawing_area;
#line 477 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gtk_widget_grab_focus (_tmp0_);
#line 479 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	x = 0;
#line 479 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	y = 0;
#line 480 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = event;
#line 480 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp2_ = _tmp1_->type;
#line 480 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp2_ == GDK_BUTTON_PRESS) {
#line 2800 "book-view.c"
		GdkEventButton* _tmp3_ = NULL;
		gdouble _tmp4_ = 0.0;
		gint _tmp5_ = 0;
		GdkEventButton* _tmp6_ = NULL;
		gdouble _tmp7_ = 0.0;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		PageView* _tmp10_ = NULL;
		PageView* _tmp11_ = NULL;
#line 481 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp3_ = event;
#line 481 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp4_ = _tmp3_->x;
#line 481 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp5_ = book_view_get_x_offset (self);
#line 481 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp6_ = event;
#line 481 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp7_ = _tmp6_->y;
#line 481 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp10_ = book_view_get_page_at (self, (gint) (_tmp4_ + _tmp5_), (gint) _tmp7_, &_tmp8_, &_tmp9_);
#line 481 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		x = _tmp8_;
#line 481 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		y = _tmp9_;
#line 481 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp11_ = _tmp10_;
#line 481 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		book_view_select_page_view (self, _tmp11_);
#line 481 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_page_view_unref0 (_tmp11_);
#line 2832 "book-view.c"
	}
#line 483 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp12_ = self->priv->selected_page;
#line 483 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp12_ == NULL) {
#line 484 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		result = FALSE;
#line 484 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		return result;
#line 2842 "book-view.c"
	}
#line 487 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp13_ = event;
#line 487 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp14_ = _tmp13_->button;
#line 487 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp14_ == ((guint) 1)) {
#line 2850 "book-view.c"
		GdkEventButton* _tmp15_ = NULL;
		GdkEventType _tmp16_ = 0;
#line 489 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp15_ = event;
#line 489 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp16_ = _tmp15_->type;
#line 489 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		if (_tmp16_ == GDK_BUTTON_PRESS) {
#line 2859 "book-view.c"
			PageView* _tmp17_ = NULL;
			gint _tmp18_ = 0;
			gint _tmp19_ = 0;
#line 490 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp17_ = self->priv->selected_page;
#line 490 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp18_ = x;
#line 490 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp19_ = y;
#line 490 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			page_view_button_press (_tmp17_, _tmp18_, _tmp19_);
#line 2871 "book-view.c"
		} else {
			GdkEventButton* _tmp20_ = NULL;
			GdkEventType _tmp21_ = 0;
#line 491 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp20_ = event;
#line 491 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp21_ = _tmp20_->type;
#line 491 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			if (_tmp21_ == GDK_BUTTON_RELEASE) {
#line 2881 "book-view.c"
				PageView* _tmp22_ = NULL;
				gint _tmp23_ = 0;
				gint _tmp24_ = 0;
#line 492 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp22_ = self->priv->selected_page;
#line 492 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp23_ = x;
#line 492 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp24_ = y;
#line 492 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				page_view_button_release (_tmp22_, _tmp23_, _tmp24_);
#line 2893 "book-view.c"
			} else {
				GdkEventButton* _tmp25_ = NULL;
				GdkEventType _tmp26_ = 0;
#line 493 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp25_ = event;
#line 493 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				_tmp26_ = _tmp25_->type;
#line 493 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
				if (_tmp26_ == GDK_2BUTTON_PRESS) {
#line 2903 "book-view.c"
					Page* _tmp27_ = NULL;
					Page* _tmp28_ = NULL;
#line 494 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp27_ = book_view_get_selected (self);
#line 494 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_tmp28_ = _tmp27_;
#line 494 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					g_signal_emit_by_name (self, "show-page", _tmp28_);
#line 494 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
					_page_unref0 (_tmp28_);
#line 2914 "book-view.c"
				}
			}
		}
	}
#line 498 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp29_ = event;
#line 498 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp30_ = _tmp29_->button;
#line 498 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp30_ == ((guint) 3)) {
#line 499 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		g_signal_emit_by_name (self, "show-menu");
#line 2927 "book-view.c"
	}
#line 501 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	result = FALSE;
#line 501 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 2933 "book-view.c"
}


static void book_view_set_cursor (BookView* self, GdkCursorType cursor) {
	GdkCursor* c = NULL;
	GdkCursorType _tmp0_ = 0;
	GdkCursorType _tmp1_ = 0;
	GdkCursorType _tmp2_ = 0;
	GdkCursorType _tmp3_ = 0;
	GdkCursor* _tmp4_ = NULL;
	GtkWidget* _tmp5_ = NULL;
	GdkWindow* _tmp6_ = NULL;
	GdkCursor* _tmp7_ = NULL;
#line 504 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 508 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->cursor;
#line 508 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = cursor;
#line 508 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp0_ == _tmp1_) {
#line 509 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_g_object_unref0 (c);
#line 509 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		return;
#line 2959 "book-view.c"
	}
#line 510 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp2_ = cursor;
#line 510 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->cursor = _tmp2_;
#line 512 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp3_ = cursor;
#line 512 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp4_ = gdk_cursor_new (_tmp3_);
#line 512 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_g_object_unref0 (c);
#line 512 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	c = _tmp4_;
#line 513 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp5_ = self->priv->drawing_area;
#line 513 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp6_ = gtk_widget_get_window (_tmp5_);
#line 513 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp7_ = c;
#line 513 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gdk_window_set_cursor (_tmp6_, _tmp7_);
#line 504 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_g_object_unref0 (c);
#line 2983 "book-view.c"
}


static gboolean book_view_motion_cb (BookView* self, GtkWidget* widget, GdkEventMotion* event) {
	gboolean result = FALSE;
	GdkCursorType cursor = 0;
	gboolean _tmp0_ = FALSE;
	PageView* _tmp1_ = NULL;
	GdkCursorType _tmp32_ = 0;
#line 516 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 516 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 516 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 518 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	cursor = GDK_ARROW;
#line 521 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = self->priv->selected_page;
#line 521 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp1_ != NULL) {
#line 3005 "book-view.c"
		GdkEventMotion* _tmp2_ = NULL;
		GdkModifierType _tmp3_ = 0;
#line 521 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp2_ = event;
#line 521 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp3_ = _tmp2_->state;
#line 521 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp0_ = (_tmp3_ & GDK_BUTTON1_MASK) != 0;
#line 3014 "book-view.c"
	} else {
#line 521 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp0_ = FALSE;
#line 3018 "book-view.c"
	}
#line 521 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp0_) {
#line 3022 "book-view.c"
		gint x = 0;
		GdkEventMotion* _tmp4_ = NULL;
		gdouble _tmp5_ = 0.0;
		gint _tmp6_ = 0;
		PageView* _tmp7_ = NULL;
		gint _tmp8_ = 0;
		gint y = 0;
		GdkEventMotion* _tmp9_ = NULL;
		gdouble _tmp10_ = 0.0;
		PageView* _tmp11_ = NULL;
		gint _tmp12_ = 0;
		PageView* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		PageView* _tmp16_ = NULL;
		GdkCursorType _tmp17_ = 0;
#line 523 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp4_ = event;
#line 523 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp5_ = _tmp4_->x;
#line 523 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp6_ = book_view_get_x_offset (self);
#line 523 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp7_ = self->priv->selected_page;
#line 523 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp8_ = page_view_get_x_offset (_tmp7_);
#line 523 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		x = (gint) ((_tmp5_ + _tmp6_) - _tmp8_);
#line 524 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp9_ = event;
#line 524 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp10_ = _tmp9_->y;
#line 524 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp11_ = self->priv->selected_page;
#line 524 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp12_ = page_view_get_y_offset (_tmp11_);
#line 524 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		y = (gint) (_tmp10_ - _tmp12_);
#line 525 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp13_ = self->priv->selected_page;
#line 525 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp14_ = x;
#line 525 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp15_ = y;
#line 525 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		page_view_motion (_tmp13_, _tmp14_, _tmp15_);
#line 526 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp16_ = self->priv->selected_page;
#line 526 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp17_ = page_view_get_cursor (_tmp16_);
#line 526 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		cursor = _tmp17_;
#line 3075 "book-view.c"
	} else {
		gint x = 0;
		gint y = 0;
		PageView* over_page = NULL;
		GdkEventMotion* _tmp18_ = NULL;
		gdouble _tmp19_ = 0.0;
		gint _tmp20_ = 0;
		GdkEventMotion* _tmp21_ = NULL;
		gdouble _tmp22_ = 0.0;
		gint _tmp23_ = 0;
		gint _tmp24_ = 0;
		PageView* _tmp25_ = NULL;
		PageView* _tmp26_ = NULL;
#line 531 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp18_ = event;
#line 531 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp19_ = _tmp18_->x;
#line 531 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp20_ = book_view_get_x_offset (self);
#line 531 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp21_ = event;
#line 531 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp22_ = _tmp21_->y;
#line 531 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp25_ = book_view_get_page_at (self, (gint) (_tmp19_ + _tmp20_), (gint) _tmp22_, &_tmp23_, &_tmp24_);
#line 531 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		x = _tmp23_;
#line 531 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		y = _tmp24_;
#line 531 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		over_page = _tmp25_;
#line 532 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp26_ = over_page;
#line 532 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		if (_tmp26_ != NULL) {
#line 3111 "book-view.c"
			PageView* _tmp27_ = NULL;
			gint _tmp28_ = 0;
			gint _tmp29_ = 0;
			PageView* _tmp30_ = NULL;
			GdkCursorType _tmp31_ = 0;
#line 534 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp27_ = over_page;
#line 534 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp28_ = x;
#line 534 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp29_ = y;
#line 534 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			page_view_motion (_tmp27_, _tmp28_, _tmp29_);
#line 535 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp30_ = over_page;
#line 535 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp31_ = page_view_get_cursor (_tmp30_);
#line 535 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			cursor = _tmp31_;
#line 3131 "book-view.c"
		}
#line 521 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_page_view_unref0 (over_page);
#line 3135 "book-view.c"
	}
#line 539 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp32_ = cursor;
#line 539 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_set_cursor (self, _tmp32_);
#line 541 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	result = FALSE;
#line 541 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 3145 "book-view.c"
}


static gboolean book_view_key_cb (BookView* self, GtkWidget* widget, GdkEventKey* event) {
	gboolean result = FALSE;
	GdkEventKey* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
#line 544 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 544 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 544 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 546 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = event;
#line 546 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = _tmp0_->keyval;
#line 546 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	switch (_tmp1_) {
#line 546 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		case 0xff50:
#line 3167 "book-view.c"
		{
			Book* _tmp2_ = NULL;
			Page* _tmp3_ = NULL;
			Page* _tmp4_ = NULL;
#line 549 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp2_ = self->priv->book;
#line 549 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp3_ = book_get_page (_tmp2_, 0);
#line 549 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp4_ = _tmp3_;
#line 549 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			book_view_select_page (self, _tmp4_);
#line 549 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_page_unref0 (_tmp4_);
#line 550 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			result = TRUE;
#line 550 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			return result;
#line 3186 "book-view.c"
		}
#line 546 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		case 0xff51:
#line 3190 "book-view.c"
		{
			PageView* _tmp5_ = NULL;
			PageView* _tmp6_ = NULL;
			PageView* _tmp7_ = NULL;
#line 552 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp5_ = self->priv->selected_page;
#line 552 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp6_ = book_view_get_prev_page (self, _tmp5_);
#line 552 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp7_ = _tmp6_;
#line 552 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			book_view_select_page_view (self, _tmp7_);
#line 552 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_page_view_unref0 (_tmp7_);
#line 553 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			result = TRUE;
#line 553 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			return result;
#line 3209 "book-view.c"
		}
#line 546 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		case 0xff53:
#line 3213 "book-view.c"
		{
			PageView* _tmp8_ = NULL;
			PageView* _tmp9_ = NULL;
			PageView* _tmp10_ = NULL;
#line 555 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp8_ = self->priv->selected_page;
#line 555 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp9_ = book_view_get_next_page (self, _tmp8_);
#line 555 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp10_ = _tmp9_;
#line 555 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			book_view_select_page_view (self, _tmp10_);
#line 555 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_page_view_unref0 (_tmp10_);
#line 556 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			result = TRUE;
#line 556 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			return result;
#line 3232 "book-view.c"
		}
#line 546 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		case 0xFF57:
#line 3236 "book-view.c"
		{
			Book* _tmp11_ = NULL;
			Book* _tmp12_ = NULL;
			guint _tmp13_ = 0U;
			Page* _tmp14_ = NULL;
			Page* _tmp15_ = NULL;
#line 558 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp11_ = self->priv->book;
#line 558 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp12_ = self->priv->book;
#line 558 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp13_ = book_get_n_pages (_tmp12_);
#line 558 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp14_ = book_get_page (_tmp11_, ((gint) _tmp13_) - 1);
#line 558 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_tmp15_ = _tmp14_;
#line 558 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			book_view_select_page (self, _tmp15_);
#line 558 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			_page_unref0 (_tmp15_);
#line 559 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			result = TRUE;
#line 559 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			return result;
#line 3261 "book-view.c"
		}
		default:
		{
#line 562 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			result = FALSE;
#line 562 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
			return result;
#line 3269 "book-view.c"
		}
	}
}


static gboolean book_view_focus_cb (BookView* self, GtkWidget* widget, GdkEventFocus* event) {
	gboolean result = FALSE;
	PageView* _tmp0_ = NULL;
#line 566 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 566 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 566 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 568 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->selected_page;
#line 568 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_set_selected_page (self, _tmp0_);
#line 569 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	result = FALSE;
#line 569 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	return result;
#line 3292 "book-view.c"
}


static void book_view_scroll_cb (BookView* self, GtkAdjustment* adjustment) {
	gboolean _tmp0_ = FALSE;
#line 572 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 572 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (adjustment != NULL);
#line 574 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->laying_out;
#line 574 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (!_tmp0_) {
#line 575 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		book_view_redraw (self);
#line 3308 "book-view.c"
	}
}


void book_view_redraw (BookView* self) {
	GtkWidget* _tmp0_ = NULL;
#line 578 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 580 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->drawing_area;
#line 580 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	gtk_widget_queue_draw (_tmp0_);
#line 3321 "book-view.c"
}


void book_view_select_page (BookView* self, Page* page) {
	Page* _tmp0_ = NULL;
	Page* _tmp1_ = NULL;
	Page* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	Page* _tmp4_ = NULL;
#line 583 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 585 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = book_view_get_selected (self);
#line 585 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = _tmp0_;
#line 585 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp2_ = page;
#line 585 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp3_ = _tmp1_ == _tmp2_;
#line 585 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_unref0 (_tmp1_);
#line 585 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp3_) {
#line 586 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		return;
#line 3347 "book-view.c"
	}
#line 588 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp4_ = page;
#line 588 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp4_ != NULL) {
#line 3353 "book-view.c"
		GHashTable* _tmp5_ = NULL;
		Page* _tmp6_ = NULL;
		gconstpointer _tmp7_ = NULL;
#line 589 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp5_ = self->priv->page_data;
#line 589 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp6_ = page;
#line 589 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp7_ = g_hash_table_lookup (_tmp5_, _tmp6_);
#line 589 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		book_view_select_page_view (self, (PageView*) _tmp7_);
#line 3365 "book-view.c"
	} else {
#line 591 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		book_view_select_page_view (self, NULL);
#line 3369 "book-view.c"
	}
}


void book_view_select_next_page (BookView* self) {
	PageView* _tmp0_ = NULL;
	PageView* _tmp1_ = NULL;
	PageView* _tmp2_ = NULL;
#line 594 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 596 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->selected_page;
#line 596 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = book_view_get_next_page (self, _tmp0_);
#line 596 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp2_ = _tmp1_;
#line 596 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_select_page_view (self, _tmp2_);
#line 596 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_view_unref0 (_tmp2_);
#line 3390 "book-view.c"
}


void book_view_select_prev_page (BookView* self) {
	PageView* _tmp0_ = NULL;
	PageView* _tmp1_ = NULL;
	PageView* _tmp2_ = NULL;
#line 599 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 601 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->selected_page;
#line 601 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp1_ = book_view_get_prev_page (self, _tmp0_);
#line 601 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp2_ = _tmp1_;
#line 601 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_select_page_view (self, _tmp2_);
#line 601 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_view_unref0 (_tmp2_);
#line 3410 "book-view.c"
}


Page* book_view_get_selected (BookView* self) {
	Page* result = NULL;
	PageView* _tmp0_ = NULL;
#line 604 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 606 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->selected_page;
#line 606 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (_tmp0_ != NULL) {
#line 3423 "book-view.c"
		PageView* _tmp1_ = NULL;
		Page* _tmp2_ = NULL;
#line 607 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp1_ = self->priv->selected_page;
#line 607 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		_tmp2_ = page_view_get_page (_tmp1_);
#line 607 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		result = _tmp2_;
#line 607 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		return result;
#line 3434 "book-view.c"
	} else {
#line 609 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		result = NULL;
#line 609 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		return result;
#line 3440 "book-view.c"
	}
}


static void g_cclosure_user_marshal_VOID__PAGE (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__PAGE) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__PAGE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_return_if_fail (n_param_values == 2);
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		data1 = closure->data;
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 3460 "book-view.c"
	} else {
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
		data2 = closure->data;
#line 3466 "book-view.c"
	}
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	callback = (GMarshalFunc_VOID__PAGE) (marshal_data ? marshal_data : cc->callback);
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	callback (data1, value_get_page (param_values + 1), data2);
#line 3472 "book-view.c"
}


static void book_view_class_init (BookViewClass * klass) {
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	book_view_parent_class = g_type_class_peek_parent (klass);
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_type_class_add_private (klass, sizeof (BookViewPrivate));
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	G_OBJECT_CLASS (klass)->finalize = book_view_finalize;
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_new ("page_selected", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__PAGE, G_TYPE_NONE, 1, TYPE_PAGE);
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_new ("show_page", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__PAGE, G_TYPE_NONE, 1, TYPE_PAGE);
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_new ("show_menu", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3489 "book-view.c"
}


static void book_view_instance_init (BookView * self) {
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv = BOOK_VIEW_GET_PRIVATE (self);
#line 27 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self->priv->selected_page = NULL;
#line 3498 "book-view.c"
}


static void book_view_finalize (GObject* obj) {
	BookView * self;
	Book* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	Book* _tmp2_ = NULL;
	guint _tmp3_ = 0U;
	Book* _tmp4_ = NULL;
	guint _tmp5_ = 0U;
	Book* _tmp6_ = NULL;
	guint _tmp7_ = 0U;
	GtkWidget* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	GtkWidget* _tmp10_ = NULL;
	guint _tmp11_ = 0U;
	GtkWidget* _tmp12_ = NULL;
	guint _tmp13_ = 0U;
	GtkWidget* _tmp14_ = NULL;
	guint _tmp15_ = 0U;
	GtkWidget* _tmp16_ = NULL;
	guint _tmp17_ = 0U;
	GtkWidget* _tmp18_ = NULL;
	guint _tmp19_ = 0U;
	GtkWidget* _tmp20_ = NULL;
	guint _tmp21_ = 0U;
	GtkWidget* _tmp22_ = NULL;
	guint _tmp23_ = 0U;
	GtkAdjustment* _tmp24_ = NULL;
	guint _tmp25_ = 0U;
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOK_VIEW, BookView);
#line 90 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp0_ = self->priv->book;
#line 90 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("page-added", TYPE_BOOK, &_tmp1_, NULL, FALSE);
#line 90 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _book_view_add_cb_book_page_added, self);
#line 91 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp2_ = self->priv->book;
#line 91 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("page-removed", TYPE_BOOK, &_tmp3_, NULL, FALSE);
#line 91 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _book_view_remove_cb_book_page_removed, self);
#line 92 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp4_ = self->priv->book;
#line 92 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("reordered", TYPE_BOOK, &_tmp5_, NULL, FALSE);
#line 92 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _book_view_reorder_cb_book_reordered, self);
#line 93 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp6_ = self->priv->book;
#line 93 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("cleared", TYPE_BOOK, &_tmp7_, NULL, FALSE);
#line 93 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _book_view_clear_cb_book_cleared, self);
#line 94 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp8_ = self->priv->drawing_area;
#line 94 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("configure-event", GTK_TYPE_WIDGET, &_tmp9_, NULL, FALSE);
#line 94 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _book_view_configure_cb_gtk_widget_configure_event, self);
#line 95 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp10_ = self->priv->drawing_area;
#line 95 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("draw", GTK_TYPE_WIDGET, &_tmp11_, NULL, FALSE);
#line 95 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _book_view_draw_cb_gtk_widget_draw, self);
#line 96 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp12_ = self->priv->drawing_area;
#line 96 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("motion-notify-event", GTK_TYPE_WIDGET, &_tmp13_, NULL, FALSE);
#line 96 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _book_view_motion_cb_gtk_widget_motion_notify_event, self);
#line 97 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp14_ = self->priv->drawing_area;
#line 97 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("key-press-event", GTK_TYPE_WIDGET, &_tmp15_, NULL, FALSE);
#line 97 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _book_view_key_cb_gtk_widget_key_press_event, self);
#line 98 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp16_ = self->priv->drawing_area;
#line 98 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("button-press-event", GTK_TYPE_WIDGET, &_tmp17_, NULL, FALSE);
#line 98 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _book_view_button_cb_gtk_widget_button_press_event, self);
#line 99 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp18_ = self->priv->drawing_area;
#line 99 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("button-release-event", GTK_TYPE_WIDGET, &_tmp19_, NULL, FALSE);
#line 99 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _book_view_button_cb_gtk_widget_button_release_event, self);
#line 100 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp20_ = self->priv->drawing_area;
#line 100 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("focus-in-event", GTK_TYPE_WIDGET, &_tmp21_, NULL, FALSE);
#line 100 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp20_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp21_, 0, NULL, (GCallback) _book_view_focus_cb_gtk_widget_focus_in_event, self);
#line 101 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp22_ = self->priv->drawing_area;
#line 101 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("focus-out-event", GTK_TYPE_WIDGET, &_tmp23_, NULL, FALSE);
#line 101 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp23_, 0, NULL, (GCallback) _book_view_focus_cb_gtk_widget_focus_out_event, self);
#line 102 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_tmp24_ = self->priv->adjustment;
#line 102 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_parse_name ("value-changed", GTK_TYPE_ADJUSTMENT, &_tmp25_, NULL, FALSE);
#line 102 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, 0, NULL, (GCallback) _book_view_scroll_cb_gtk_adjustment_value_changed, self);
#line 18 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_book_unref0 (self->priv->book);
#line 19 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_g_hash_table_unref0 (self->priv->page_data);
#line 27 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_page_view_unref0 (self->priv->selected_page);
#line 30 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_g_object_unref0 (self->priv->drawing_area);
#line 33 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_g_object_unref0 (self->priv->scroll);
#line 34 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	_g_object_unref0 (self->priv->adjustment);
#line 15 "/home/bob/bzr/simple-scan/3.4/src/book-view.vala"
	G_OBJECT_CLASS (book_view_parent_class)->finalize (obj);
#line 3624 "book-view.c"
}


GType book_view_get_type (void) {
	static volatile gsize book_view_type_id__volatile = 0;
	if (g_once_init_enter (&book_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BookViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) book_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BookView), 0, (GInstanceInitFunc) book_view_instance_init, NULL };
		GType book_view_type_id;
		book_view_type_id = g_type_register_static (GTK_TYPE_VBOX, "BookView", &g_define_type_info, 0);
		g_once_init_leave (&book_view_type_id__volatile, book_view_type_id);
	}
	return book_view_type_id__volatile;
}



